'use strict';

var GanttChartMeasureController = angular.module('GanttChartMeasureController', []);

GanttChartMeasureController.controller('GanttChartMeasureCtrl', ['$scope', '$filter', 'Construcao', 'Relatorio', 'CacheApp',
  ($scope, $filter, Construcao, Relatorio, CacheApp) => {
    $scope.construcao = {};

    $scope.construcao = CacheApp.getConstrucao();
    $scope.dataInicio = new Date($scope.construcao.DataInicio);
    $scope.dataFim = new Date($scope.construcao.DataFim);

    var tempoRestante = Math.abs($scope.dataFim - $scope.dataInicio);
    $scope.dias = Math.ceil(tempoRestante / (1000 * 3600 * 24))+2;

    $scope.getListaDias = () => {
    $scope.listaDias = [];
        for (var i=0;i<$scope.dias-1;i++) {
            var dia = new Date($scope.construcao.DataInicio);
            dia.setDate(dia.getDate() + i);
            $scope.listaDias.push(dia);
        }
    }

    $scope.getPlanejaEtapa = () => {
        $scope.getListaDias();
        $scope.TotalMedicao = 0;
        Construcao.getPlanejaEtapa($scope.construcao.Id,
            (data) => {
                $scope.etapas = data.Instance;
                $scope.Medicoes = [];

                var idxMain = -1;
                var countSub = 0;
                for (var i in $scope.etapas) {
                    $scope.etapas[i].AvancoTotal = 0;
                    var etapa = $scope.etapas[i];
                    var id = etapa.IdEtapa;

                    etapa.QtdDiasInicio = etapa.QtdDiasInicio ? etapa.QtdDiasInicio : 0;
                    var ini = etapa.QtdDiasInicio;

                    etapa.QtdDiasExecucao = etapa.QtdDiasExecucao ? etapa.QtdDiasExecucao : 0;
                    var fim = etapa.QtdDiasInicio + etapa.QtdDiasExecucao;

                    etapa.DataInicio = new Date($scope.construcao.DataInicio);
                    etapa.DataInicio.setDate(etapa.DataInicio.getDate() + ini);

                    etapa.DataFim = new Date($scope.construcao.DataInicio);
                    etapa.DataFim.setDate(etapa.DataFim.getDate() + fim-1);
                    
                    if (etapa.Ordem.indexOf('.') < 0) {
                        idxMain = i;
                        countSub = 0;
                    }
                    if (etapa.Ordem.indexOf($scope.etapas[idxMain].Ordem+'.') == 0) {
                        if(countSub == 0)
                            $scope.etapas[idxMain].DataInicio = etapa.DataInicio;
                        if($scope.etapas[idxMain].DataInicio > etapa.DataInicio)
                            $scope.etapas[idxMain].DataInicio = etapa.DataInicio;
                        if($scope.etapas[idxMain].DataFim < etapa.DataFim)
                            $scope.etapas[idxMain].DataFim = etapa.DataFim;
                        countSub++;
                    }

                    etapa.TotalDiasExecucaoReal = 0;

                    for (var j in etapa.Medicoes) {
                        var medicao = etapa.Medicoes[j];
                        medicao.QtdDiasInicio = medicao.QtdDiasInicio ? medicao.QtdDiasInicio : 0;;
                        var iniM = medicao.QtdDiasInicio;
    
                        medicao.QtdDiasExecucao = medicao.QtdDiasExecucao ? medicao.QtdDiasExecucao : 0;
                        var fimM = medicao.QtdDiasInicio + medicao.QtdDiasExecucao;
     
                        medicao.DataInicio = new Date($scope.construcao.DataInicio);
                        medicao.DataInicio.setDate(medicao.DataInicio.getDate() + iniM);
    
                        medicao.DataFim = new Date($scope.construcao.DataInicio);
                        medicao.DataFim.setDate(medicao.DataFim.getDate() + fimM-1);

                        etapa.TotalDiasExecucaoReal += medicao.QtdDiasExecucao;
                    }
                }

                Relatorio.getBoletimMedicao(3, $scope.construcao.Id, $filter("date")($scope.dataInicio, 'yyyy-MM-dd'), $filter("date")($scope.dataFim, 'yyyy-MM-dd'),
                    (data) => {
                        var boletimMedicao = data.Instance;

                        // for (var i in boletimMedicao.Etapas) {
                        //     var idx = -1;
                        //     var idxItem = -1;
                        //     for (var j in $scope.etapas)
                        //         if ($scope.etapas[j].Etapa == boletimMedicao.Etapas[i].Etapa) {
                        //             idx = j;
                        //             break;
                        //         }

                        //     if (idx == -1)
                        //         for (var j in $scope.etapas)
                        //             for (var k in boletimMedicao.Etapas[i].Itens)
                        //                 if ($scope.etapas[j].Etapa == boletimMedicao.Etapas[i].Itens[k].Material) {
                        //                     idx = j;
                        //                     idxItem = k;
                        //                     break;
                        //                 }

                        //     if (idx != -1 && idxItem == -1) {
                        //         var total = 0;
                        //         $scope.etapas[idx].ValorTotal = 0;
                        //         for (var j in boletimMedicao.Etapas[i].Itens) {
                        //             $scope.etapas[idx].ValorTotal += boletimMedicao.Etapas[i].Itens[j].ValorAvancoAcum;
                        //             total += boletimMedicao.Etapas[i].Itens[j].Total;
                        //         }
                        //         $scope.etapas[idx].AvancoTotal = $scope.etapas[idx].ValorTotal/total;
                        //     }

                        //     if (idx != -1 && idxItem != -1) {
                        //         console.log('ENTROU!');
                        //         var total = 0;
                        //         $scope.etapas[idx].ValorTotal = boletimMedicao.Etapas[i].Itens[idxItem].ValorAvancoAcum;
                        //         // for (var j in boletimMedicao.Etapas[i].Itens) {
                        //         //     $scope.etapas[idx].ValorTotal += boletimMedicao.Etapas[i].Itens[j].ValorAvancoAcum;
                        //         //     total += boletimMedicao.Etapas[i].Itens[j].Total;
                        //         // }
                        //         $scope.etapas[idx].AvancoTotal = $scope.etapas[idx].ValorTotal/boletimMedicao.Etapas[i].Itens[idxItem].Total;
                        //     }
                        // }
                        // console.log($scope.etapas);

                        for (var i in $scope.etapas) {
                            var idx = -1;
                            var idxItem = -1;
                            for (var j in boletimMedicao.Etapas)
                                if ($scope.etapas[i].Etapa == boletimMedicao.Etapas[j].Etapa) {
                                    idx = j;
                                    break;
                                }

                            if (idx == -1)
                                for (var j in boletimMedicao.Etapas)
                                    for (var k in boletimMedicao.Etapas[j].Itens)
                                        if ($scope.etapas[i].Etapa == boletimMedicao.Etapas[j].Itens[k].Material) {
                                            idx = j;
                                            idxItem = k;
                                            break;
                                        }

                            if (idx != -1 && idxItem == -1) {
                                var total = 0;
                                $scope.etapas[i].ValorTotal = 0;
                                for (var j in boletimMedicao.Etapas[idx].Itens) {
                                    $scope.etapas[i].ValorTotal += boletimMedicao.Etapas[idx].Itens[j].ValorAvancoAcum;
                                    total += boletimMedicao.Etapas[idx].Itens[j].Total;
                                }
                                $scope.etapas[i].AvancoTotal = $scope.etapas[i].ValorTotal/total;
                            }

                            if (idx != -1 && idxItem != -1) {
                                $scope.etapas[i].ValorTotal = boletimMedicao.Etapas[idx].Itens[idxItem].ValorAvancoAcum;
                                $scope.etapas[i].AvancoTotal = $scope.etapas[i].ValorTotal/boletimMedicao.Etapas[idx].Itens[idxItem].Total;
                            }
                        }                        

                        $scope.table = $scope.getHtmlTable();
                    }
                );
                  
            }
        );
    }
    $scope.getPlanejaEtapa();


    $scope.getHtmlTable = () => {
        var table = '' + 
        '    <table class="table tableoff"> ' + 
        '    <thead> ' + 
        '        <tr class="tr-fonteTitulo"> ' + 
        '            <th>Etapa</th> ' + 
        '            <th>Início</th> ' + 
        '            <th>Fim</th> ' + 
        '            <th>Duração</th> ' + 
        '            <th ng-repeat="item in listaDias">{{item | date:\'dd/MM\'}}</th> ' + 
        '        </tr> ' + 
        '    </thead> ' + 
        '    <tbody>';
        for (var i in $scope.etapas) {
            var item = $scope.etapas[i];
            item.DiasMensurados = Math.round(item.TotalDiasExecucaoReal*item.AvancoTotal);
            var medido = (item.AvancoTotal*100).toFixed(2).replace('.',',');
            var textoPopover = 'De ' + $filter('date')(item.DataInicio,'dd/MM/yyyy') + ' até ' + $filter('date')(item.DataFim,'dd/MM/yyyy') + '. Dia: {{dia | date:\'dd/MM\'}}. Medido: ' + medido + '%';
            table +=
            '<tr class="tr-fonteItem">' +
                '<td>' + item.Ordem + ' ' + item.Etapa + '</td>' + 
                '<td>' + $filter('date')(item.DataInicio,'dd/MM/yyyy') + '</td>' +
                '<td>' + $filter('date')(item.DataFim,'dd/MM/yyyy') + '</td>' +
                '<td>' + item.TotalDiasExecucaoReal + '</td>' + 
                '<td ng-repeat="dia in listaDias" ng-style="validaData(etapas[' + i + '].Medicoes,dia) && {\'background-color\': \'#263143\'}"><div data-placement="left" data-content="'+ textoPopover +'" rel="popover" data-original-title="'+item.Etapa+'" data-trigger="hover" style="cursor: default">&nbsp;&nbsp;&nbsp;&nbsp;<div></td>' +
            '</tr>' +
            '<tr class="tr-fonteItem"><td colspan="4">Medido: '+ medido +'%</td><td ng-repeat="dia in listaDias" ng-style="validaDataMedicao(etapas[' + i + '],dia,'+item.DiasMensurados+') && {\'background-color\': \'#FAA200\'}"><div data-placement="left" data-content="'+ textoPopover +'" rel="popover" data-original-title="'+item.Etapa+'" data-trigger="hover" style="cursor: default">&nbsp;&nbsp;&nbsp;&nbsp;<div></td></tr>';
        }
        table += '</tbody></table>';

        setTimeout(function() {
            $('[rel = "popover"]').popover();
        }, 100);
        
        return table;
    }      

    $scope.validaData = function(medicoes, dia) {
        var result = false;
        for (var i in medicoes) {
            var medicao = medicoes[i];
            if (new Date(medicao.DataInicio) <= dia && dia <= new Date(medicao.DataFim) && medicao.QtdDiasExecucao > 0) {
                result = true;
                break;
            }
        }
        return result;
    }

    $scope.validaDataMedicao = function(etapa, dia, DiasMensurados) {
        var result = false;
        var medicoes = etapa.Medicoes;
        for (var i in medicoes) {
            var medicao = medicoes[i];
            var dtMed = new Date(medicao.DataInicio);
            dtMed.setDate(dtMed.getDate() + DiasMensurados-1);
            if (new Date(medicao.DataInicio) <= dia && dia <= new Date(medicao.DataFim) && dia <= dtMed && DiasMensurados > 0) {
                result = true;
                break;
            }

            DiasMensurados -= medicao.QtdDiasExecucao;
        }

        return result;
    }

}]);
